
#include <stdio.h>
#include <stdlib.h>

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	FILE	*hp;
	int	lo,hi,idx,code;

	if (argc!=1 && argc!=2) Error("usage : hp2comment {HiPic}");

	if (argc==1)
	    hp=stdin;
	else
	    if ((hp=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fgetc(hp)!='I' || fgetc(hp)!='M') Error("bad magic number.");

	if ((lo=fgetc(hp))==EOF ||
	    (hi=fgetc(hp))==EOF) Error("bad comment length.");

	fseek(hp,60L,SEEK_CUR);	/* size, offset, type and reserved data */

	for (idx=lo+hi*256; idx>0; idx--) {
	    if ((code=fgetc(hp))==EOF) Error("unexpected end of file.");

	    putchar(code);
	}
	putchar('\n');

	return 0;
}
